#include <iostream>
#include <fstream>
#include <jsoncpp/json/json.h>
int main(int argc, char **argv)/**/
{
    if(argc!=4)
	{
		std::cout << "Wrong usage:"<<std::endl<<
		"\t"<<	argv[0]<<" input_file configuration_file output_file"<<std::endl;
		return -1;
	}

	std::string input_file=argv[1];
	std::string configuration_file=argv[2];
	std::string output_file=argv[3];

	std::cout<<"Running a dummy program..."<<std::endl<<std::endl;

    /* Print input file */
	std::cout<<"::::::::::::::::: Printing Input :::::::::::::::::"<<std::endl;
	std::ifstream input(input_file, std::ifstream::binary);
	std::string line;
	while (std::getline(input, line)) std::cout<<line<<std::endl;

	/* Read Configurations */
    std::cout<<"::::::::::::::::: Reading Configuration :::::::::::::::::"<<std::endl;
	//Defaults
	int int_config=0;
	std::string string_config="null";
	std::string list_config="default";
	bool bool_config=false;
	Json::Reader json_reader;
	Json::Value json_root;
	bool valid_root;
	try
	{
		std::ifstream configuration_descriptor(configuration_file, std::ifstream::binary);
		valid_root=json_reader.parse(configuration_descriptor,json_root);
		if (!valid_root)
		{
			std::cout  << "Failed to parse configuration\n"
			<< json_reader.getFormattedErrorMessages();
		}
		else
		{
			int_config=json_root["int_config"].asUInt64();
			string_config=json_root["string_config"].asString();
			list_config=json_root["list_config"].asString();
			bool_config=json_root["bool_config"].asBool();
		}
	}
	catch(...)
	{
		std::cout<<"Using defaults"<<std::endl;
	}

    /* Write output */
    std::cout<<"::::::::::::::::: Writting Output :::::::::::::::::"<<std::endl;
    std::ofstream output(output_file, std::ifstream::binary);
    Json::Value json_output;
    Json::Value json_configurations;
    json_configurations["int_config"]=int_config;
    json_configurations["string_config"]=string_config;
    json_configurations["list_config"]=list_config;
    json_configurations["bool_config"]=bool_config;
    Json::Value json_configurations_array(Json::arrayValue);
    json_configurations_array.append(json_configurations);
    json_output["configurations"]=json_configurations_array;
    output<<json_output<<std::endl;

	std::cout<<"Done"<<std::endl;
	return 0;
}
